---
kind: secret
name: drone-deploy-config
get:
  path: drone-deploy-config
  name: kubeconfig
---
kind: secret
name: private-image-pull
get:
  path: private-image-pull
  name: .dockerconfigjson
---
kind: pipeline
type: kubernetes
name: default
image_pull_secrets:
  - private-image-pull
trigger:
  branch:
  event:
  - pull_request

steps:
- name: pushBuildIdInRedis
  image: rg.fr-par.scw.cloud/guru/flask-client
  pull: always
  commands:
  - sh /app/curl.sh buildNumber ${DRONE_SOURCE_BRANCH} ${DRONE_BUILD_NUMBER}

- name: staticAnalysis
  image: rg.fr-par.scw.cloud/guru/conftest
  pull: always
  commands:
  # Containers must NOT run as root
  # Deployment must select pods using app label selector
  # This pod must expose a readiness probe using process check
  # This pod must expose a liveness  probe on HTTP  port
  - echo "$DRONE_COMMIT_AUTHOR should fix deployment.yaml to pass this step"
  - conftest test /drone/src/deploy/deployment.yaml --policy /project
  depends_on:
  - pushBuildIdInRedis

- name: kubernetesBestPratices
  image: rg.fr-par.scw.cloud/guru/kube-score
  pull: always
  commands:
  # Deployment must limit containers CPU and RAM usage
  # Containers should have an image pull policy to ensure that latest version is always up
  # Containers should have a security context
  - echo "$DRONE_COMMIT_AUTHOR should fix deployment.yaml to pass this step"
  - /kube-score/kube-score score /drone/src/deploy/deployment.yaml --ignore-test pod-networkpolicy --ignore-test deployment-has-poddisruptionbudget --ignore-test deployment-has-host-podantiaffinity
  depends_on:
  - pushBuildIdInRedis

- name: findDeployedImage
  image: rg.fr-par.scw.cloud/guru/yq
  pull: always
  commands:
    - echo "$DRONE_REPO_OWNER is performing this action. It should never fail."
    - yq eval '.spec.template.spec.containers[0].image' /drone/src/deploy/deployment.yaml > /drone/src/image.txt
  depends_on:
  - pushBuildIdInRedis

- name: checkImageOrigin
  image: rg.fr-par.scw.cloud/guru/swiss
  pull: always
  settings:
    kubeconfig_content:
      from_secret: drone-deploy-config
  commands:
    - echo "$DRONE_COMMIT_AUTHOR should fix deployment.yaml to pass this step"
    - |
      image=`cat "/drone/src/image.txt"`
      if [ $${image:0:24} = \rg.fr-par.scw.cloud/guru ]
      then
      echo "Image belongs to an authorized repository"
      else
      echo "Images must be pull from rg.fr-par.scw.cloud/guru/ repository"
      echo "Available images for repository rg.fr-par.scw.cloud/guru are nginx:1.13.12-alpine, nginx:1.14-alpine, nginx:1.15-alpine, nginx:1.16-alpine, nginx:1.17-alpine, nginx:1.18-alpine, nginx:1.19-alpine, nginx:1.20-alpine "
      exit 1
      fi
  depends_on:
  - findDeployedImage

- name: unpackImage
  image: docker:dind
  volumes:
  - name: dockersock
    path: /var/run
  commands:
    - echo "$DRONE_REPO_OWNER is performing this action. It should never fail."
    - sleep 5
    - docker pull `cat "/drone/src/image.txt"`
    - docker save `cat "/drone/src/image.txt"` -o /drone/src/image.tar
  depends_on:
  - checkImageOrigin

- name: securityScan
  image: rg.fr-par.scw.cloud/guru/trivy:0.16.0
  pull: always
  volumes:
  - name: trivy
    path: /root/.cache
  # Nginx 1.23.1 is CVE exposed
  failure: ignore
  commands:
  # Containers should NOT have any CRITICAL CVE
    - echo "$DRONE_COMMIT_AUTHOR should fix deployment.yaml to pass this step"
    - trivy --exit-code 1 --light --severity CRITICAL --input /drone/src/image.tar
  depends_on:
  - unpackImage

- name: deployApplication
  image: rg.fr-par.scw.cloud/guru/swiss
  pull: always
  settings:
    kubeconfig_content:
      from_secret: drone-deploy-config
  commands:
    - echo "$DRONE_REPO_OWNER is performing this action. It should never fail."
    - echo "$${PLUGIN_KUBECONFIG_CONTENT}" > $${HOME}/.kube/config
    - namespace=`echo $${DRONE_SOURCE_BRANCH} | awk '{print tolower($0)}'`
    - kubectl create namespace $${namespace} || true
    - kubectl replace --force -f /drone/src/config/configmap.yaml --namespace $${namespace}
    - kubectl replace --force -f /drone/src/deploy/deployment.yaml --namespace $${namespace}
  depends_on:
  - securityScan
  - kubernetesBestPratices
  - staticAnalysis

- name: testApplication
  image: rg.fr-par.scw.cloud/guru/swiss
  pull: always
  settings:
    kubeconfig_content:
      from_secret: drone-deploy-config
  commands:
    - echo "$DRONE_COMMIT_AUTHOR should fix deployment.yaml to pass this step"
    - echo "$${PLUGIN_KUBECONFIG_CONTENT}" > $${HOME}/.kube/config
    - namespace=`echo $${DRONE_SOURCE_BRANCH} | awk '{print tolower($0)}'`
    - kubectl rollout status deploy/nginx-deployment --namespace $${namespace} --timeout 30s
  depends_on:
  - deployApplication

- name: clean
  image: rg.fr-par.scw.cloud/guru/swiss
  pull: always
  settings:
    kubeconfig_content:
      from_secret: drone-deploy-config
  commands:
    # If you have fixed everything else, this should run smoothly
    - echo "$DRONE_REPO_OWNER is performing this action. It should never fail."
    - echo "$${PLUGIN_KUBECONFIG_CONTENT}" > $${HOME}/.kube/config
    - namespace=`echo $${DRONE_SOURCE_BRANCH} | awk '{print tolower($0)}'`
    - kubectl delete namespace $${namespace}
  depends_on:
  - testApplication

- name: giveNextChallenge
  image: rg.fr-par.scw.cloud/guru/flask-client
  pull: always
  commands:
  - sh /app/curl.sh buildSuccess ${DRONE_SOURCE_BRANCH}
  - echo "Ask Baghwan about the current clue using abhra -c current"
  depends_on:
  - clean

services:
- name: docker
  image: docker:dind
  privileged: true
  volumes:
  - name: dockersock
    path: /var/run

volumes:
- name: dockersock
  temp: {}
- name: trivy
  host:
    path: /tmp/cache/.trivy

---
kind: signature
hmac: 6638344f93364498c634303c52081472c34314da6e2c75aa370b1a96e52e253a

...
